Package: org.codehaus.groovy.ant

## [Java] Class Groovy

- org.codehaus.groovy.ant.Groovy

- Executes a series of Groovy statements.

  Statements can either be read in from a text file using the src attribute or from between the enclosing groovy tags.

- - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `Path` | `classpath`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected void` | `addClassPathes(GroovyClassLoader classLoader)` Adds the class paths (if any)
    `` | `void` | `addFileset(FileSet set)` Adds a set of files (nested fileset attribute).
    `` | `void` | `addText(String txt)` Set an inline command to execute.
    `` | `Commandline.Argument` | `createArg()`
    `` | `Path` | `createClasspath()` Returns a new path element that can be configured.
    `` | `protected void` | `execGroovy(String txt, PrintStream out)` Exec the statement.
    `` | `void` | `execute()` Load the file and then execute it
    `` | `Path` | `getClasspath()` Gets the classpath.
    `` | `boolean` | `getParameters()` Returns true if parameter metadata generation has been enabled.
    `` | `static void` | `main(String[] args)`
    `` | `protected void` | `printResults(PrintStream out)` print any results in the statement.
    `` | `protected void` | `runStatements(Reader reader, PrintStream out)` Read in lines and execute them.
    `` | `void` | `setAppend(boolean append)` Whether output should be appended to or overwrite an existing file.
    `` | `void` | `setClasspath(Path classpath)` Sets the classpath for loading.
    `` | `void` | `setClasspathRef(Reference ref)` Set the classpath for loading using the classpath reference.
    `` | `void` | `setConfigscript(String configscript)` Sets the configuration script for the groovy compiler configuration.
    `` | `void` | `setContextClassLoader(boolean contextClassLoader)` Setting to true will cause the contextClassLoader to be set with the classLoader of the shell used to run the script.
    `` | `void` | `setFork(boolean fork)` Should the script be executed using a forked process.
    `` | `void` | `setIncludeAntRuntime(boolean includeAntRuntime)` Should the system classpath be included on the classpath when forking.
    `` | `void` | `setIndy(boolean indy)` Sets the indy flag to enable or disable invokedynamic
    `` | `void` | `setOutput(File output)` Set the output file; optional, defaults to the Ant log.
    `` | `void` | `setParameters(boolean parameters)` If true, generates metadata for reflection on method parameter names (jdk8+ only).
    `` | `void` | `setScriptBaseClass(String scriptBaseClass)` Set the script base class name
    `` | `void` | `setSrc(File srcFile)` Set the name of the file to be run.
    `` | `void` | `setStacktrace(boolean stacktrace)` Enable compiler to report stack trace information if a problem occurs during compilation.
    `` | `void` | `setUseGroovyShell(boolean useGroovyShell)` Should a new GroovyShell be used when forking.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Java` | `execute, setError, setInput, handleInput, setClassname, setClasspathRef, createClasspath, createPermissions, setResultProperty, setOutputproperty, addConfiguredRedirector, setClasspath, setModule, setDir, setFork, setTimeout, getCommandLine, setArgs, setOutput, setJar, createJvmarg, createUpgrademodulepath, addSyspropertyset, createBootclasspath, setNewenvironment, executeJava, setModulepath, createArg, setJvm, setModulepathRef, setJvmargs, setInputString, setErrorProperty, setJVMVersion, addEnv, setFailonerror, setLogError, setAppend, addAssertions, getSysProperties, addSysproperty, setCloneVm, setMaxmemory, createModulepath, clearArgs, setSpawn, log, log, log, log, init, bindToOwner, reconfigure, perform, getRuntimeConfigurableWrapper, setRuntimeConfigurableWrapper, maybeConfigure, getOwningTarget, setOwningTarget, setTaskName, setTaskType, getTaskType, getTaskName, clone, getLocation, getDescription, getProject, setDescription, setProject, setLocation, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Property Detail

    - #### Path classpath

  - ### Method Detail

    - #### protected void addClassPathes(GroovyClassLoader classLoader)

      Adds the class paths (if any)

      Parameters:
        `classLoader` - the classloader to configure

    - #### public void addFileset(FileSet set)

      Adds a set of files (nested fileset attribute).

      Parameters:
        `set` - the fileset representing source files

    - #### public void addText(String txt)

      Set an inline command to execute. NB: Properties are not expanded in this text.

      Parameters:
        `txt` - the inline groovy commands to execute

    - #### public Commandline.Argument createArg()

    - #### public Path createClasspath()

      Returns a new path element that can be configured. Gets called for instance by Ant when it encounters a nested <classpath> element.

      Returns:
        the resulting created path

    - #### protected void execGroovy(String txt, PrintStream out)

      Exec the statement.

      Parameters:
        `txt` - the groovy source to exec
        `out` - not used?

    - #### public void execute()

      Load the file and then execute it

    - #### public Path getClasspath()

      Gets the classpath.

      Returns:
        Returns a Path

    - #### public boolean getParameters()

      Returns true if parameter metadata generation has been enabled.

    - #### public static void main(String[] args)

    - #### protected void printResults(PrintStream out)

      print any results in the statement.

      Parameters:
        `out` - the output PrintStream to print to

    - #### protected void runStatements(Reader reader, PrintStream out)

      Read in lines and execute them.

      throws:
        java.io.IOException if something goes wrong
      Parameters:
        `reader` - the reader from which to get the groovy source to exec
        `out` - the outputstream to use

    - #### public void setAppend(boolean append)

      Whether output should be appended to or overwrite an existing file. Defaults to false.

      Parameters:
        `append` - set to true to append

    - #### public void setClasspath(Path classpath)

      Sets the classpath for loading.

      Parameters:
        `classpath` - The classpath to set

    - #### public void setClasspathRef(Reference ref)

      Set the classpath for loading using the classpath reference.

      Parameters:
        `ref` - the refid to use

    - #### public void setConfigscript(String configscript)

      Sets the configuration script for the groovy compiler configuration.

      Parameters:
        `configscript` - path to the configuration script

    - #### public void setContextClassLoader(boolean contextClassLoader)

      Setting to true will cause the contextClassLoader to be set with the classLoader of the shell used to run the script. Not used if fork is true. Not allowed when running from Maven but in that case the context classLoader is set appropriately for Maven.

      Parameters:
        `contextClassLoader` - set to true to set the context classloader

    - #### public void setFork(boolean fork)

      Should the script be executed using a forked process. Defaults to false.

      Parameters:
        `fork` - true if the script should be executed in a forked process

    - #### public void setIncludeAntRuntime(boolean includeAntRuntime)

      Should the system classpath be included on the classpath when forking. Defaults to true.

      Parameters:
        `includeAntRuntime` - true if the system classpath should be on the classpath

    - #### public void setIndy(boolean indy)

      Sets the indy flag to enable or disable invokedynamic

      Parameters:
        `indy` - true means invokedynamic support is active

    - #### public void setOutput(File output)

      Set the output file; optional, defaults to the Ant log.

      Parameters:
        `output` - the output file

    - #### public void setParameters(boolean parameters)

      If true, generates metadata for reflection on method parameter names (jdk8+ only). Defaults to false.

      Parameters:
        `parameters` - set to true to generate metadata.

    - #### public void setScriptBaseClass(String scriptBaseClass)

      Set the script base class name

      Parameters:
        `scriptBaseClass` - the name of the base class for scripts

    - #### public void setSrc(File srcFile)

      Set the name of the file to be run. The folder of the file is automatically added to the classpath. Required unless statements are enclosed in the build file

      Parameters:
        `srcFile` - the file containing the groovy script to execute

    - #### public void setStacktrace(boolean stacktrace)

      Enable compiler to report stack trace information if a problem occurs during compilation.

      Parameters:
        `stacktrace` - set to true to enable stacktrace reporting

    - #### public void setUseGroovyShell(boolean useGroovyShell)

      Should a new GroovyShell be used when forking. Special variables won't be available but you don't need Ant in the classpath.

      Parameters:
        `useGroovyShell` - true if GroovyShell should be used to run the script directly